/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyHeapSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;
	/**
	 * 
	 */
	public MyHeapSort() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		int length = a.length;
		for( int marker = length / 2; marker > 0; marker-- ) {
			downheap( a, marker, length );
			pause();
		}
		do {
			int tmp = a[0];
			a[0] = a[length - 1];
			a[length - 1] = tmp;
			length = length - 1;
			pause( length );
			downheap( a, 1, length );
		} while( length > 1 );
	}
	
	public void downheap( int a[], int marker, int length ) throws Exception {
		int tmp = a[marker - 1];
		while( marker <= length / 2 ) {
			int marker2 = marker + marker;
			if( ( marker2 < length ) && ( a[marker2 - 1] < a[marker2] ) ) {
				marker2++;
			}
			if( tmp >= a[marker2 - 1] ) {
				break;
			}
			else {
				a[marker - 1] = a[marker2 - 1];
				marker = marker2;
//				pause();
			}
		}
		a[marker - 1] = tmp;
//		pause();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med HeapSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med HeapSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
