/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyQuickBubbleSort extends AlgorithmExtension implements SortAlgorithm {

private int[] arr;
private Vector vector;
	
	/**
	 * 
	 */
	public MyQuickBubbleSort() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort(int[] a) throws Exception {
		sort(a, 0, a.length - 1);
	}
	
	public void sort( int a[], int lo, int hi ) throws Exception {
		int low = lo;
		int high = hi;
		pause( low, high );
		//Bubble sort if the number of elements is less than 6 
		if( ( high - low ) <= 6 ) {
			bsort( a, low, high );
			return;
		}
		//Pick a pivot and move it out of the way
		int pivot = a[(low + high) / 2];
		a[(low + high) / 2] = a[high];
		a[high] = pivot;

		while( low < high ) {
			//Search forward from a[lo] until an element is found that
			//is greater than the pivot or low >= high
			while( a[low] <= pivot && low < high ) {
				low++;
			}
			//Search backward from a[hi] until element is found that
			//is less than the pivot, or high <= low
			while( pivot <= a[high] && low < high ) {
				high--;
			}
			//Swap elements a[low] and a[high]
			if( low < high ) {
				int tmp = a[low];
				a[low] = a[high];
				a[high] = tmp;
				pause();
			}
		}
		//Put the median in the "center" of the list
		a[hi] = a[high];
		a[high] = pivot;
		//Recursive calls, elements a[lo0] to a[low-1] are less than or
		//equal to pivot, elements a[high+1] to a[hi] are greater than pivot.
		sort( a, lo, low - 1 );
		sort( a, high + 1, hi );
	}

	public void bsort( int a[], int low, int high ) throws Exception {
		for( int j = high; j > low; j-- ) {
			for( int i = low; i < j; i++ ) {
				if( a[i] > a[i + 1] ) {
					int tmp = a[i];
					a[i] = a[i + 1];
					a[i + 1] = tmp;
					pause();
				}
			}
		}
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if (arr != null) {
			System.out.println("Array sorteret med Quick & BubbleSort printes ud");
			for (int i = 0; i < arr.length; i++) {
				System.out.print(arr[i] + ",");
			}
			System.out.println("");
		}
		//hvis vector != null, s print Vector
		if (vector != null) {
			System.out.println("Vector sorteret med Quick & BubbleSort printes ud");
			for (int i = 0; i < vector.size(); i++) {
				System.out.println("" + vector.elementAt(i));
			}
		}
	}
}
