/*
 * Created on 07-07-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package algoritmer;

import java.util.*;

/**
 * @author Knud Albrechtsen (SnakeByte)
 */
public class MyShellSort extends AlgorithmExtension implements SortAlgorithm {

private Vector vector;
private int[] arr;
	/**
	 * 
	 */
	public MyShellSort() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(int[])
	 */
	public void sort( int[] a ) throws Exception {
		int marker = 1;
		//find the largest h value possible 
		while( ( marker * 3 + 1 ) < a.length ) {
			marker = 3 * marker + 1;
		}
		//while h remains larger than 0 
		while( marker > 0 ) {
			//for each set of elements (there are h sets)
			for( int i = marker - 1; i < a.length; i++ ) {
				//pick the last element in the set
				int marker2 = a[i];
				int j = i;
				//compare the element at B to the one before it in the set
				//if they are out of order continue this loop, moving
				//elements "back" to make room for B to be inserted.
				for( j = i; ( j >= marker ) && ( a[j - marker] > marker2 ); j -= marker ) {
					if( getStopsort() ) {
						return;
					}
					a[j] = a[j - marker];
					pause( i, j );
				}
				//insert B into the correct place
				a[j] = marker2;
				pause( j );
			}
			//all sets h-sorted, now decrease set size
			marker = marker / 3;
		}
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#sort(java.util.Vector)
	 */
	public void sort( Vector v ) throws Exception {
		
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getArray()
	 */
	public int[] getArray() {
		return arr;
	}
	
	/* (non-Javadoc)
	 * @see algoritmer.SortAlgorithm#getVector()
	 */
	public Vector getVector() {
		return vector;
	}
	
	/*-------------------flles printmetode------------------*/
	/* (non-Javadoc)
	 * @see test.SortAlgorithm#print()
	 */
	public void print() {
		//hvis array != null, s print array
		if( arr != null ) {
			System.out.println( "Array sorteret med ShellSort printes ud" );
			for( int i = 0; i < arr.length; i++ ) {
				System.out.print( arr[i] + "," );
			}
			System.out.println( "" );
		}
		//hvis vector != null, s print Vector
		if( vector != null ) {
			System.out.println( "Vector sorteret med ShellSort printes ud" );
			for( int i = 0; i < vector.size(); i++ ) {
				System.out.println( "" + vector.elementAt( i ) );
			}
		}
	}
}
