
/*
 * Created on 17-06-2003
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
package gui;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*;
import algoritmer.*;
import utils.*;

/**
 * @author SnakeByte
 *
 * The contents of this file may be used for 
 * private or educational use only.
 */
public class MyFrame extends JFrame implements ActionListener {

private JButton start, stop, reset;
private JComboBox combo;
private MyJPanel pan;
private Font font = new Font( "helvetica", Font.PLAIN, 12 );
private GridBagLayout layout = new GridBagLayout();
private GridBagConstraints con;
	/**
	 * 
	 * 
	 */
	public MyFrame() {
		super( "Sort Engine 2" );
		addWindowListener( new WindowHandler() );
		getContentPane().setLayout( layout );
		URL url = MyFrame.class.getResource( "/images/SnakeByte-Icon.gif" );
		Image img = Toolkit.getDefaultToolkit().getImage( url );
		setIconImage( img );

		start = new JButton( "Start" );
		start.setFont( font );
		start.setPreferredSize( new Dimension( 59, 27 ) );
		start.addActionListener( this );
		con = createGBC( 0, 0, 1, 1 );
		add( start, con );
		
		reset = new JButton( "Reset" );
		reset.setFont( font );
		reset.setPreferredSize( new Dimension( 67, 27 ) );
		reset.addActionListener( this );
		con = createGBC( 1, 0, 1, 1 );
		add( reset, con );
		
		stop = new JButton( "Stop" );
		stop.setFont( font );
		stop.setPreferredSize( new Dimension( 59, 27 ) );
		stop.addActionListener( this );
		con = createGBC( 2, 0, 1, 1 );
		add( stop, con );
		
		combo = new JComboBox();
		combo.setFont( font );
		combo.setPreferredSize( new Dimension( 137, 27 ) );
		combo.addActionListener( this );
		combo.addItem( "" );
		combo.addItem( "InsertionSort" );
		combo.addItem( "BubbleSort" );
		combo.addItem( "MergeSort" );
		combo.addItem( "QuickSort" );
		combo.addItem( "SelectionSort" );
		combo.addItem( "Bidirectional BubbleSort" );
		combo.addItem( "Extra Storage MergeSort" );
		combo.addItem( "HeapSort" );
		combo.addItem( "Quick og BubbleSort" );
		combo.addItem( "EQSort" );
		combo.addItem( "ShakerSort" );
		combo.addItem( "ShellSort" );
		con = createGBC( 3, 0, 1, 1 );
		add( combo, con );
		
		pan = new MyJPanel( this );
		pan.setRandom();
		con = createGBC( 0, 1, 4, 1 );
		add( pan, con );
		
		pack();
		setSize( 350, 350 );
		setResizable( false );
		setVisible( true );
	}

	public void reset() {
		pan.setRandom();
		repaint();
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed( ActionEvent e ) {
		Object source = e.getSource();
		if( source == start ) {
			reset.setEnabled( false );
			combo.setEnabled( false );
			pan.startSort();
		}
		else if( source == reset ) {
			reset();
		}
		else if( source == stop ) {
			pan.stop();
			reset.setEnabled( true );
			combo.setEnabled( true );
		}
		else if( source == combo ) {
			if( !combo.getSelectedItem().equals( "" ) ) {
				start.setEnabled( true );
				reset.setEnabled( true );
				stop.setEnabled( true );
				if( combo.getSelectedItem().equals( "InsertionSort" ) ) {
					pan.setInsertion( new MyInsertionSort() );
				}
				else if( combo.getSelectedItem().equals( "BubbleSort" ) ) {
					pan.setBubble( new MyBubbleSort() );
				}
				else if( combo.getSelectedItem().equals( "MergeSort" ) ) {
					pan.setMerge( new MyMergeSort() );
				}
				else if( combo.getSelectedItem().equals( "QuickSort" ) ) {
					pan.setQuick( new MyQuickSort() );
				}
				else if( combo.getSelectedItem().equals( "SelectionSort" ) ) {
					pan.setSelection( new MySelectionSort() );
				}
				else if( combo.getSelectedItem().equals( "Bidirectional BubbleSort" ) ) {
					pan.setBidirBubble( new MyBidirectionalBubbleSort() );
				}
				else if( combo.getSelectedItem().equals( "Extra Storage MergeSort" ) ) {
					pan.setExtraStorMerge( new MyExtraStorageMergeSort() );
				}
				else if( combo.getSelectedItem().equals( "HeapSort" ) ) {
					pan.setHeapSort( new MyHeapSort() );
				}
				else if( combo.getSelectedItem().equals( "Quick og BubbleSort" ) ) {
					pan.setQBSort( new MyQuickBubbleSort() );
				}
				else if( combo.getSelectedItem().equals( "EQSort" ) ) {
					pan.setEQSort( new MyEQSort() );
				}
				else if( combo.getSelectedItem().equals( "ShakerSort" ) ) {
					pan.setShakerSort( new MyShakerSort() );
				}
				else if( combo.getSelectedItem().equals( "ShellSort" ) ) {
					pan.setShellSort( new MyShellSort() );
				}
			}
			else {
				start.setEnabled( false );
				reset.setEnabled( false );
				stop.setEnabled( false );
			}
		}
	}
	
	private void add( JComponent component, GridBagConstraints gbc ) {
		layout.setConstraints( component, gbc );
		getContentPane().add( component );
	}

	private GridBagConstraints createGBC( int x, int y, int width, int height ) {
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = width;
		gbc.gridheight = height;
		return gbc;
	}
}
