/*
 * Created on 18-06-2003
 */
package gui;

import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import algoritmer.*;

/**
 * @author jb3580
 *
 * This contents of this file may be used for
 *  private or educational use only.
 */
public class MyJPanel extends JPanel implements Runnable {

private int[] random;//The array that is being sorted.
private Thread kicker;//The thread that is sorting (or null).
private int h1 = -1;//The high water mark.
private int h2 = -1;//The low water mark.
private MyInsertionSort insertion;
private MyBubbleSort bubble;
private MyMergeSort merge;
private MyQuickSort quick;//The sorting algorithm (or null).
private MySelectionSort selection;
private MyBidirectionalBubbleSort bidibubble;
private MyExtraStorageMergeSort exstormerge;
private MyHeapSort heapsort;
private MyQuickBubbleSort qbsort;
private MyEQSort eqsort;
private MyShakerSort shakersort;
private MyShellSort shellsort;

	/**
	 * 
	 * 
	 */
	public MyJPanel( MyFrame f ) {
		super();
		setBackground( Color.lightGray );
		setPreferredSize( new Dimension( 315, 280 ) );
		setBorder( BorderFactory.createEtchedBorder( EtchedBorder.RAISED ) );
	}
	
	public void setInsertion( MyInsertionSort m ) {
		insertion = m;
		bubble = null;
		merge = null;
		quick = null;
		selection = null;
		bidibubble = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setBubble( MyBubbleSort b ) {
		bubble = b;
		insertion = null;
		merge = null;
		quick = null;
		selection = null;
		bidibubble = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setMerge( MyMergeSort m ) {
		merge = m;
		insertion = null;
		bubble = null;
		quick = null;
		selection = null;
		bidibubble = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setQuick( MyQuickSort m ) {
		quick = m;
		insertion = null;
		bubble = null;
		merge = null;
		selection = null;
		bidibubble = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setSelection( MySelectionSort m ) {
		selection = m;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		bidibubble = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setBidirBubble( MyBidirectionalBubbleSort m ) {
		bidibubble = m;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		exstormerge = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setExtraStorMerge( MyExtraStorageMergeSort m ) {
		exstormerge = m;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setHeapSort( MyHeapSort m ) {
		heapsort = m;
		exstormerge = null;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setQBSort( MyQuickBubbleSort m ) {
		qbsort = m;
		exstormerge = null;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		heapsort = null;
		eqsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setEQSort( MyEQSort m ) {
		eqsort = m;
		exstormerge = null;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		heapsort = null;
		qbsort = null;
		shakersort = null;
		shellsort = null;
	}
	
	public void setShakerSort( MyShakerSort m ) {
		shakersort = m;
		exstormerge = null;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shellsort = null;
	}
	
	public void setShellSort( MyShellSort m ) {
		shellsort = m;
		exstormerge = null;
		bidibubble = null;
		selection = null;
		insertion = null;
		bubble = null;
		merge = null;
		quick = null;
		heapsort = null;
		qbsort = null;
		eqsort = null;
		shakersort = null;
	}
	
	public void setRandom() {
		random = makeRandom();
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run() {
		try {
			if( insertion != null ) {
				insertion.setParent( this );
				insertion.init();
				insertion.sort( random );
			}
			else if( bubble != null ) {
				bubble.setParent( this );
				bubble.init();
				bubble.sort( random );
			}
			else if( merge != null ) {
				merge.setParent( this );
				merge.init();
				merge.sort( random );
			}
			else if( quick != null ) {
				quick.setParent( this );
				quick.init();
				quick.sort( random );
			}
			else if( selection != null ) {
				selection.setParent( this );
				selection.init();
				selection.sort( random );
			}
			else if( bidibubble != null ) {
				bidibubble.setParent( this );
				bidibubble.init();
				bidibubble.sort( random );
			}
			else if( exstormerge != null ) {
				exstormerge.setParent( this );
				exstormerge.init();
				exstormerge.sort( random );
			}
			else if( heapsort != null ) {
				heapsort.setParent( this );
				heapsort.init();
				heapsort.sort( random );
			}
			else if( qbsort != null ) {
				qbsort.setParent( this );
				qbsort.init();
				qbsort.sort( random );
			}
			else if( eqsort != null ) {
				eqsort.setParent( this );
				eqsort.init();
				eqsort.sort( random );
			}
			else if( shakersort != null ) {
				shakersort.setParent( this );
				shakersort.init();
				shakersort.sort( random );
			}
			else if( shellsort != null ) {
				shellsort.setParent( this );
				shellsort.init();
				shellsort.sort( random );
			}
		}
		catch( Exception e ) {
			System.out.println( "Run: Exception:" + e );
		}
	}
	
	/**
	 * Stop the applet. Kill any sorting algorithm that
	 * is still sorting.
	 */
	public synchronized void stop() {
		if( kicker != null ) {
			try {
				kicker.stop();
			}
			catch( IllegalThreadStateException e ) {
				System.out.println( "IllegalThreadStateException: " + e );
			}
			kicker = null;
		}
		if( insertion != null ) {
			insertion.stopSort();
		}
		else if( bubble != null ) {
			bubble.stopSort();
		}
		else if( merge != null ) {
			merge.stopSort();
		}
		else if( quick != null ) {
			quick.stopSort();
		}
		else if( selection != null ) {
			selection.stopSort();
		}
		else if( bidibubble != null ) {
			bidibubble.stopSort();
		}
		else if( exstormerge != null ) {
			exstormerge.stopSort();
		}
		else if( heapsort != null ) {
			heapsort.stopSort();
		}
		else if( qbsort != null ) {
			qbsort.stopSort();
		}
		else if( eqsort != null ) {
			eqsort.stopSort();
		}
		else if( shakersort != null ) {
			shakersort.stopSort();
		}
		else if( shellsort != null ) {
			shellsort.stopSort();
		}
	}

	/**
	 * For a Thread to actually do the sorting. This routine makes
	 * sure we do not simultaneously start several sorts if the user
	 * repeatedly clicks on the sort item.  It needs to be
	 * synchronoized with the stop() method because they both
	 * manipulate the common kicker variable.
	 */
	public synchronized void startSort() {
		if( kicker == null || !kicker.isAlive() ) {
			makeRandom();
			repaint();
			kicker = new Thread( this );
			kicker.start();
			repaint();
			getParent().repaint();
		}
	}
	
	/* (non-Javadoc)
	 * @see java.awt.Component#paint(java.awt.Graphics)
	 */
	public void paint( Graphics g ) {
		super.paint( g );
		Graphics2D g2d = (Graphics2D) g;
		
		int xkoord = 5;
		int ykoord = 10;
		//de gamle linier fjernes
		g2d.setColor( Color.lightGray );
		for (int i = 0; i < random.length; i++) {
			g2d.drawLine( xkoord, ykoord, xkoord + 200, ykoord );
			ykoord += 2;
		}
		ykoord = 10;
		//de usorterede linier tegnes
		g2d.setColor( Color.black );
		for( int i = 0; i < random.length; i++ ) {
			g2d.drawLine( xkoord, ykoord, xkoord + random[i], ykoord );
			ykoord += 2;
		}
		//stter farverne p hi og lo
		if (h1 >= 0) {
			g2d.setColor( Color.red );
			ykoord = ( h1 * 2 ) + 10;
			g2d.drawLine( xkoord, ykoord, xkoord + 200, ykoord );
		}
		if (h2 >= 0) {
			g2d.setColor( Color.blue );
			ykoord = ( h2 * 2 ) + 10;
			g2d.drawLine( xkoord, ykoord, xkoord + 200, ykoord );
		}
	}
	
	/**
	 * 
	 * @return
	 */
	private int[] makeRandom() {
		int[] arr = new int[100];
		
		for( int i = 0; i < arr.length; i++ ) {
			arr[i] = (int)( Math.random() * 200 );
		}
		return arr;
	}
	
	/**
	 * Pause a while.
	 * @see SortAlgorithm
	 */
	public void pause() {
		pause(-1, -1);
	}

	/**
	 * Pause a while, and draw the high water mark.
	 * @see SortAlgorithm
	 */
	public void pause(int H1) {
		pause(H1, -1);
	}

	/**
	 * Pause a while, and draw the low&high water marks.
	 * @see SortAlgorithm
	 */
	public void pause(int H1, int H2) {
		h1 = H1;
		h2 = H2;
		if (kicker != null) {
			repaint();
		}
		try {
			Thread.sleep( 20 );
		}
		catch( InterruptedException e ) {
			System.out.println( "InterruptedException: " + e );
		}
	}
	
	/**
	 * 
	 * @return
	 */
	public int getH1() {
		return h1;
	}

	/**
	 * 
	 * @return
	 */
	public int getH2() {
		return h2;
	}

	/**
	 * 
	 * @param i
	 */
	public void setH1( int i ) {
		h1 = i;
	}

	/**
	 * 
	 * @param i
	 */
	public void setH2( int i ) {
		h2 = i;
	}

	
}
